﻿# -*- coding: utf-8 -*-
from setuphelpers import *


"""
https://inkscape.org/release/inkscape-1.3.2/windows/64-bit/:
    Please note: Always remove/uninstall the previous version before updating!

"""


def install():
    bin_name = glob.glob("inkscape-*-x64.exe")[0]

    # Uninstalling older version of software
    for to_uninstall in installed_softwares(uninstallkey="Inkscape"):
        if Version(to_uninstall["version"]) < Version(control.get_software_version()) or force:
            print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
            killalltasks(ensure_list(control.impacted_process))
            run(uninstall_cmd(to_uninstall["key"]))
            wait_uninstallkey_absent(to_uninstall["key"])

    # Installing the package
    install_exe_if_needed(
        bin_name,
        silentflags="/S /ALLUSER=ON /CONTEXTMENU=OFF",
        key="Inkscape",
        min_version=control.get_software_version(),
    )
